freeslot("MT_22_GREHORIZ","MT_22_GREDIAG","MT_22_GRESPRG",
				 "MT_22_YELHORIZ","MT_22_YELDIAG","MT_22_YELSPRG",
				 "MT_22_REDHORIZ","MT_22_REDDIAG","MT_22_REDSPRG",
				 "MT_22_BLUHORIZ","MT_22_BLUDIAG","MT_22_BLUSPRG")


--this is to rawset the object flags (the ones we see in zone builder) THANK YOU LAT

if alsprings then
	return
end
rawset(_G, "alsprings", true)

local mtf_flags = {
	"MTF_EXTRA",
	"MTF_OBJECTFLIP",
	"MTF_SPECIAL",
	"MTF_AMBUSH",
}

for i = 1, #mtf_flags
	rawset(_G, mtf_flags[i], 2^(i-1))
end

local function initializesprings() --keeping my sanity thriugh this code lol
	if not mapheaderinfo[gamemap].altsprings then return end
	for spring in thinkers.iterate("mobj") do
		if not spring or spring and not(spring.flags & MF_SPRING) then continue end
		if spring.info.damage and not(spring.info.mass) then spring.horizontal = true end

		if spring.info.damage and spring.info.mass then spring.diagonal = true end

		if not(spring.info.damage) and spring.info.mass then spring.vertical = true end
		--now that we went thourhg hell here, less work afterwards]

		spring.scale = tonumber(mapheaderinfo[gamemap].springsize)
		spring.flags = $ |MF_NOGRAVITY --REALLY???
		spring.momz = 0


		if spring.type == MT_22_GRESPRG or spring.type == MT_22_GREDIAG then spring.info.mass = tonumber(mapheaderinfo[gamemap].verticalgreypower) * FRACUNIT spring.color = 2 spring.greytier = true end
		if spring.type == MT_22_GREDIAG or spring.type == MT_22_GREHORIZ then spring.info.damage = tonumber(mapheaderinfo[gamemap].horizontalgreypower) * FRACUNIT spring.color = 2 spring.greytier = true end

		if spring.type == MT_22_YELSPRG or spring.type == MT_22_YELDIAG then spring.info.mass = tonumber(mapheaderinfo[gamemap].verticalyellowpower) * FRACUNIT spring.color = 46 spring.yelltier = true end
		if spring.type == MT_22_YELDIAG or spring.type == MT_22_YELHORIZ then spring.info.damage = tonumber(mapheaderinfo[gamemap].horizontalyellowpower) * FRACUNIT spring.color = 46 spring.yelltier = true end

		if spring.type == MT_22_REDSPRG or spring.type == MT_22_REDDIAG then spring.info.mass = tonumber(mapheaderinfo[gamemap].verticalredpower) * FRACUNIT spring.color = 25 spring.redtier = true end
		if spring.type == MT_22_REDDIAG or spring.type == MT_22_REDHORIZ then spring.info.damage = tonumber(mapheaderinfo[gamemap].horizontalredpower) * FRACUNIT spring.color = 25 spring.redtier = true end

		if spring.type == MT_22_BLUSPRG or spring.type == MT_22_BLUDIAG then spring.info.mass = tonumber(mapheaderinfo[gamemap].verticalbluepower) * FRACUNIT spring.color = 86 spring.bluetier = true end
		if spring.type == MT_22_BLUDIAG or spring.type == MT_22_BLUHORIZ then spring.info.damage = tonumber(mapheaderinfo[gamemap].horizontalbluepower) * FRACUNIT spring.color = 86 spring.bluetier = true end
		
		if spring.spawnpoint.options & MTF_EXTRA then 
			spring.multiply = tonumber(mapheaderinfo[gamemap].multiplier) 
			spring.scale = $ + ($/3)
		end
		--increase their radius so you dont need BIG IMMENSE SPRINGS to make sure anyone will miss the set
		spring.radius = $ *2
		--spring.height = $ *3
	end
end

--initialize some vals so the game wont yell when trying to acces them lol
local function initializepvars(p) --initialize these things
	p.sprnang = 0
	p.sprnpow = 0
	p.sprntoppow = 0
	p.sprnspeed = 0
	p.sprncolor = 0
	p.moveang = 0
	p.spring = nil
	p.sprncoord = {x=0, y=0, z=0}	
	p.sprncd = 0
	p.brakeammount = 1
	p.wasonground = false
	p.airtime = 0
end

local function K_SpawnSparkleTrailL(mo)
	local rad = (mo.radius*2)>>FRACBITS
	local sparkle
	local i

	for i = 0, 1 do

		local newx = mo.x - mo.momx*2 + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newy = mo.y - mo.momy*2 + (P_RandomRange(-rad, rad)<<FRACBITS)
		local newz = mo.z - mo.momz*2 + (P_RandomRange(0, mo.height>>FRACBITS)<<FRACBITS)

		sparkle = P_SpawnMobj(newx, newy, newz, MT_SPARKLETRAIL)
		--K_FlipFromObject(sparkle, mo);
		sparkle.eflags = (sparkle.eflags & ~MFE_VERTICALFLIP)|(mo.eflags & MFE_VERTICALFLIP)
		sparkle.flags2 = (sparkle.flags2 & ~MF2_OBJECTFLIP)|(mo.flags2 & MF2_OBJECTFLIP)

		if (sparkle.eflags & MFE_VERTICALFLIP) then
			sparkle.z = $ + mo.height - FixedMul(mo.scale, sparkle.height)
		end
		
		--P_SetTarget(&sparkle->target, mo);
		sparkle.destscale = mo.destscale
		sparkle.scale = mo.scale
		sparkle.color = mo.color
		--//sparkle->colorized = mo->colorized;
	end
	sparkle.state =  S_KARTINVULN_LARGE1
end

local function springcollision(mt, mt2)
	if not(mt.flags & MF_SPRING) then return end --no point on keep going from this point
	if not(mt2.player or (mt2.player and mt2.player.valid)) or (mt2.player and mt2.player.spectator) then return end	--really guys, lets save some processing lol
	if (mt2.z >= mt.z-(mt2.height) and mt2.z <= mt.z + mt2.height) and mt2.player.sprncd <=0 then --yeeaaaah makes sense to check z position
	--not (P_PlayerInPain(mt2.player) or mt2.player.kartstuff[k_spinouttimer] > 0 or mt2.player.kartstuff[k_squishedtimer] > 0) then -- this is NO MORE i dont think 
		local player = mt2.player --fuck it not dealing with mt2 anymore lol
		local spring = mt -- either mt 
		local ground = P_IsObjectOnGround(player.mo) -- yes we wanna use this lol
		player.sprnspeed = FixedMul(spring.info.damage,FixedSqrt(FixedMul(mapobjectscale + (mapobjectscale - player.mo.scale), FixedMul(spring.scale, spring.multiply or FRACUNIT))))
		player.sprncolor = spring.color
		player.sprnang = spring.angle
		player.sprnpow = FixedMul(spring.info.damage,FixedSqrt(FixedMul(mapobjectscale + (mapobjectscale - player.mo.scale), FixedMul(spring.scale, spring.multiply or FRACUNIT))))
		player.spring = spring
		player.sprntoppow = FixedMul(spring.info.damage,FixedSqrt(FixedMul(mapobjectscale + (mapobjectscale - player.mo.scale), FixedMul(spring.scale, spring.multiply or FRACUNIT))))
		player.sprncoord = {x = spring.x, y = spring.y, z = spring.z}
		player.springreadjust = true
		player.horiaircase = nil
		player.sprncd = 2
		player.wasonground = false
		--player.mo.momz = 0
		player.fmomz = 0

		if spring.horizontal then --horizonbtal BOES
			--adjust to player speed if going faster
			if player.oldspeed /3 > player.sprnspeed then 
				player.sprnspeed = player.oldspeed /6
				player.sprnpow = player.oldspeed /6
				player.sprntoppow = player.oldspeed /3
			end
			if spring.spawnpoint.options & MTF_SPECIAL then 
				player.sprntoppow = $ + ($*(50+(spring.info.damage/FRACUNIT))/100)
				player.sprnpow = max(player.speed*(40+(spring.info.damage/FRACUNIT))/100,$+( $*(10+(spring.info.damage/FRACUNIT))/100))
				player.moveang = spring.angle
			end		
		end

		if spring.diagonal then --diagonal BOES

		end


		if spring.vertical then --vertical BOES
			player.sprnspeed = FixedMul(spring.info.mass,FixedSqrt(FixedMul(mapobjectscale + (mapobjectscale - player.mo.scale), FixedMul(spring.scale, spring.multiply or FRACUNIT))))
			player.sprnpow = FixedMul(spring.info.mass,FixedSqrt(FixedMul(mapobjectscale + (mapobjectscale - player.mo.scale), FixedMul(spring.scale, spring.multiply or FRACUNIT))))
			player.sprntoppow = FixedMul(spring.info.mass,FixedSqrt(FixedMul(mapobjectscale + (mapobjectscale - player.mo.scale), FixedMul(spring.scale, spring.multiply or FRACUNIT))))
			
			if not player.vertbouncecount then player.vertbouncecount = 0 end
			player.vertbouncecount = $ +1
			if spring.spawnpoint.options & MTF_SPECIAL then --stop player speed
				player.mo.momx = 0
				player.mo.momy = 0
			end
 
			if spring.spawnpoint.options & MTF_AMBUSH then --redirect speed to spring direction
				player.mo.momx = FixedMul(player.speed, cos(player.mo.angle))
				player.mo.momy = FixedMul(player.speed, sin(player.mo.angle))
			end

			--saving player if stuck on vertical springs
			if player.vertbouncecount > 2 then
				player.mo.momx = FixedMul(16 * FRACUNIT, cos(player.mo.angle))
				player.mo.momy = FixedMul(16 * FRACUNIT, sin(player.mo.angle))
			end

		end
		if spring.spawnpoint.options & MTF_AMBUSH then player.mo.angle = spring.angle end

	end

end


local function playersprungthink(p)
	if not p.spring then return end
	if not p.spring.valid then return end
	p.moveang = R_PointToAngle2(0,0, p.mo.momx, p.mo.momy)
	if p.kartstuff[k_squishedtimer] ~= 0 then p.brakeammount, p.sprnpow,p.sprntoppow,p.sprnspeed,p.spring = 0, 0, 0, 0, nil return end
	-- three springs types, horizontal taking priority
	searchBlockmap("lines", function(mo, line)
		if line then p.wallang = R_PointToAngle2(line.v2.x, line.v2.y, line.v1.x, line.v1.y) end
	end, p.mo)

	--behavior is: should move player ONLY IF in the ground
	--else just push around midair , maybe add teir respective powers too
	local pground = P_IsObjectOnGround(p.mo) --preserving my sanity here
	
	if p.springreadjust then
		--if (p.spring.horizontal and not(p.spring.spawnpoint.options & MTF_SPECIAL))
		--or (p.spring.vertical and not(p.spring.spawnpoint.options & MTF_SPECIAL)) then
			
			local hscale = mapobjectscale + (mapobjectscale - p.mo.scale) --ported from P_dospring
			local vscale = mapobjectscale + (p.mo.scale - mapobjectscale)
			local vertispeed = p.spring.info.mass
			local horizspeed = p.spring.info.damage
			local finalSpeedH = FixedDiv(horizspeed, hscale)
			local finalSpeedV = FixedDiv(vertispeed, vscale) --that's new becuz diag springs
			local pSpeed = p.oldspeed/3 --your speed makes diag springs stronger but must be going fast
			if pSpeed > finalSpeedH then
					finalSpeedH = pSpeed
			end
			if pSpeed > finalSpeedV then
					finalSpeedV = pSpeed
			end
				if horizspeed and (p.spring.horizontal or p.spring.diagonal) then P_InstaThrust(p.mo, p.spring.angle,FixedMul(finalSpeedH,FixedSqrt(FixedMul(hscale, FixedMul(p.spring.scale, p.spring.multiply or FRACUNIT))))) end
				if vertispeed and (p.spring.vertical or p.spring.diagonal) then p.mo.momz = FixedMul(finalSpeedV,FixedSqrt(FixedMul(vscale, FixedMul(p.spring.scale, p.spring.multiply or FRACUNIT)))) end
		--end	

		if p.spring.vertical or p.spring.diagonal then --replace player to spring
			P_TeleportMove(p.mo, p.sprncoord.x, p.sprncoord.y, p.sprncoord.z + p.mo.height)
			if p.spring.eflags & MFE_VERTICALFLIP then P_TeleportMove(p.mo, p.sprncoord.x, p.sprncoord.y, p.sprncoord.z - p.mo.height) end
		end
		if p.spring.horizontal then
			p.mo.momz = 0
			if p.mo.standingslope then
				p.mo.z = P_GetZAt(p.mo.standingslope, p.mo.x + p.mo.momx, p.mo.y + p.mo.momy)  --REALLY IM TIRED OF SPRING TRAPING YOU INTI SLOPES
				if p.mo.eflags & MFE_VERTICALFLIP then
					p.mo.z = P_GetZAt(p.mo.standingslope, p.mo.x + p.mo.momx, p.mo.y + p.mo.momy) -p.mo.height --REALLY IM TIRED OF SPRING TRAPING YOU INTI SLOPES
				end
			end
		end
		p.springreadjust = false
	end

	p.mo.color = p.sprncolor
	K_SpawnSparkleTrailL(p.mo)
	p.mo.color = p.skincolor
	
	if pground then p.vertbouncecount = 0 p.wasonground = true end

	if p.sprnpow <= 0  then p.brakeammount, p.sprnpow, p.spring = 0, 0, nil end 

	--if you brake, yo ucan slow down and make spring effectless more too
	if p.cmd.buttons & BT_BRAKE and leveltime%7 == 0 then p.brakeammount = $ + 3 end
	if not(p.cmd.buttons & BT_BRAKE) and leveltime%4 == 0 then p.brakeammount = $ - 1 end
	--horizontal springs
	if p.spring and p.spring.horizontal then ---gotta do this comparison here too
	if p.kartstuff[k_justbumped] then p.sprnpow = $ - $ / 94 p.sprnspeed = $ - $/72 end
		--if p.sprnpow >= p.sprntoppow /2 and not pground and not(p.mo.flags2 & MF2_OBJECTFLIP) then  p.mo.momz = max(-FRACUNIT*2,$) end
		--if p.sprnpow >= p.sprntoppow /2 and not pground and (p.mo.flags2 & MF2_OBJECTFLIP) then  p.mo.momz = min(FRACUNIT*2,$) end
		if p.sprnpow >= p.sprntoppow*25/100 and not pground and p.wasonground == false then 
			if not(p.mo.flags2 & MF2_OBJECTFLIP) then 
				--p.mo.momz = 0
				p.fmomz = $ - p.airtime * (FRACUNIT/32)
				p.mo.momz = max(p.fmomz, p.mo.momz)
			end
			if p.mo.flags2 & MF2_OBJECTFLIP then 
				p.fmomz = $ + p.airtime * (FRACUNIT/32)
				p.mo.momz = min(p.fmomz, p.mo.momz)
			end
		end
		if p.sprnpow >= p.sprntoppow*25/100 and not pground and p.wasonground == true then 
			if not(p.mo.flags2 & MF2_OBJECTFLIP) then 
				--p.mo.momz = 0
				p.fmomz = $ - p.airtime * (FRACUNIT/8)
				p.mo.momz = max(p.fmomz, p.mo.momz)
			end
			if p.mo.flags2 & MF2_OBJECTFLIP then 
				p.fmomz = $ + p.airtime * (FRACUNIT/8)
				p.mo.momz = min(p.fmomz, p.mo.momz)
			end
		end
		p.sprnpow = max(-1, $ - p.sprntoppow/(84-p.brakeammount))
		if p.kartstuff[k_offroad] then p.sprnpow = max(-1, $ - 512) end
		if p.spring.spawnpoint.options & MTF_SPECIAL then
			if pground then p.horiaircase = true end
			p.sprnspeed = $ - ($/256)
			if not pground and not p.horiaircase then p.horiaircase= true  P_InstaThrust(p.mo, p.sprnang, p.sprnspeed+(p.sprnspeed*(125-p.brakeammount)/100)) end
			if p.sprnpow >=  (p.sprntoppow/((p.spring.info.damage/FRACUNIT)/10)) and pground then P_InstaThrust(p.mo, p.sprnang, p.sprnspeed+(p.sprnspeed*(125-p.brakeammount)/100)) end
			if p.sprnpow < (p.sprntoppow/((p.spring.info.damage/FRACUNIT)/10)) and pground then P_Thrust(p.mo, p.moveang or p.sprnang, p.sprnspeed*8/100) end
			
			if p.cmd.buttons & BT_ATTACK then
				p.attackpressed = $ + 1
			else
				p.attackpressed = 0
			end
			--okay i tired to do something
			if (p.kartstuff[k_itemtype] == KITEM_SNEAKER and p.attackpressed == 1 )
			or (p.kartstuff[k_itemtype] == KITEM_ROCKETSNEAKER and p.kartstuff[k_rocketsneakertimer] > 0 and p.attackpressed == 1 )  then
				if gamespeed == 0 then p.sprnspeed = $ + (53740+768 *(FRACUNIT/8)) *8/100 p.sprnpow = p.sprnspeed end
				if gamespeed == 1 then p.sprnspeed = $ + (32768 *(FRACUNIT/8)) *8/100 p.sprnpow = p.sprnspeed end
				if gamespeed == 2 then p.sprnspeed = $ + (17294+768 *(FRACUNIT/8))*8/100 p.sprnpow = p.sprnspeed end --p.sprntoppow = p.sprnspeed end
				if p.kartstuff[k_itemtype] == KITEM_SNEAKER then  p.kartstuff[k_itemamount] = $ -1 end 
				if p.kartstuff[k_itemtype] == KITEM_ROCKETSNEAKER then  p.kartstuff[k_rocketsneakertimer] = $ -2*TICRATE  end
			end

			if p.mo.eflags & MFE_JUSTBOUNCEDWALL then
				if p.moveang - p.wallang < ANGLE_90 then
					p.sprnang = p.wallang + ANGLE_45
					p.sprnpow = $ - ($/64)
					p.sprnspeed = $ - $/32
				end
				if p.moveang - p.wallang >= ANGLE_90 then
					p.sprnang = p.wallang + ANGLE_90 + ANGLE_45
					p.sprnpow = $ - ($/64)
					p.sprnspeed = $ - $/32
				end
			end

		end
	end

	if p.spring and p.spring.diagonal then
		--only this becuz of trail effect
		p.sprnpow = $ -  (p.sprntoppow / 64) --have more effect midair
	end

	if p.spring and p.spring.vertical then
		--only this becuz of trail effect
		p.sprnpow = $ -  (p.sprntoppow / 64)
	end

end
local loaded
addHook("ThinkFrame", do	
	if leveltime < 1 then return end
	if not mapheaderinfo[gamemap].altsprings then return end
	if leveltime == 10 then print('SPRING LOADED') end
	if leveltime == 1 then 
		for p in players.iterate do 
			initializepvars(p)
		end  
	end 
	for p in players.iterate do 
		if leveltime == 12 and not loaded then
			CONS_Printf(p, '\131Alternative springs lua made by Lighto')
			CONS_Printf(p, '\130Version: AR01')
			loaded = true
		end
		if not(p.valid or p.mo and p.mo.valid ) or p.spectator then continue end
		if not p.springreadjust then p.oldspeed = p.speed end
		p.sprncd = max(0, $-1)
		if P_IsObjectOnGround(p.mo) == true then p.vertbouncecount = 0 p.airtime = 0 end
		if P_IsObjectOnGround(p.mo) == false and leveltime%4 == 0 then p.airtime = $ + 1 end
		--if p.cmd.buttons & BT_ATTACK then P_TeleportMove(p.mo, -2720<<FRACBITS,-1696<<FRACBITS, 0) end
		--if p.cmd.buttons & BT_BRAKE then p.kartstuff[k_squishedtimer] = 50 end --p.mo.momx = 0 p.mo.momy = 0 end
		playersprungthink(p)
	end
		
end)


addHook("MobjCollide", springcollision, MT_NULL)

addHook("MapLoad", initializesprings)


